diff --git a/rathaxes/samples/e1000/e1000.blt b/rathaxes/samples/e1000/e1000.blt
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/e1000.blt
+++ b/rathaxes/samples/e1000/e1000.blt
@@ -238,487 +483,87 @@
             }
         }
 
-        map
+        method init(e1000::MMIO io, Builtin::number desc_count)
         {
-            size: ((${self}).size);
-            dma_base: ((${self}).dma_base);
-        }
-    }
-
-    /*
-     * Ring of e1000::TxDescriptors, this is a bit similar to the Rx ring except
-     * that we don't really have to manage the skbuffs themselves (they are
-     * given to use by the kernel).
-     *
-     * - size: total size of the ring in bytes.
-     * - base: address of the ring (we can't use the typedef here until we get
-     *   CNorm unstrict);
-     * - dma_base: (physical) address of the ring where the device can access
-     *   the different descriptors;
-     * - skbuffs: the skbuffs associated with each descriptor of the ring;
-     * - head: index on the head of the ring;
-     * - tail: index on the tail of the ring.
-     *
-     * Keep in mind that the head and tail fields are, obviously, not
-     * synchronized with TDT/TDH on the device.
-     */
-    template type   e1000::TxRing()
-    {
-        decl    data_types()
-        {
-            unsigned int                    size;
-            /* XXX: can't use ${e1000::TxDescriptor} here: */
-            ${e1000::TxDescriptor.ref}      base; /* rename to descs */
-            dma_addr_t                      dma_base;
-            ${Socket::SKBuff}               skbuffs[${config.tx_ring_size}];
-            unsigned short                  head;
-            unsigned short                  tail;
+            ${self.ring.init(local.io, local.desc_count, self.desc_size)};
         }
 
-        chunk   LKM::prototypes()
+        method alloc()
         {
-            static void         rtx_e1000_tx_ring_clean(${e1000::TxRing.ref});
-            static unsigned int rtx_e1000_tx_ring_descriptors_remaining(${e1000::TxRing.ref});
-            static int          rtx_e1000_tx_ring_tso_cksum_offload(${e1000::TxRing.ref}, ${Socket::SKBuff.ref});
-            static void         rtx_e1000_tx_ring_put(${e1000::TxRing.ref}, ${Socket::SKBuff.ref});
-            /* FIXME: See issue #54 */
-            static void         rtx_e1000_tx_ring_start_xmit(${e1000::TxRing.ref}, /*const*/ ${e1000::Context.ref});
-        }
-
-        chunk   LKM::code()
-        {
-            static void         rtx_e1000_tx_ring_clean(${e1000::TxRing.ref} self)
-            {
-                ${e1000::TxDescriptor.ref}  tx_desc;
-                bool                        done;
-
-                for (; self->head != self->tail; self->head++)
-                {
-                    tx_desc = &self->base[self->head];
-                    done = tx_desc->upper.fields.status & E1000_TXD_STAT_DD;
-                    if (!done)
-                        break ;
-                }
-
-                pr_info("%s: tx_ring_clean: moving head to %d/%d", ${config.name}, self->head, ${config.tx_ring_size});
-            }
-
-            static unsigned int rtx_e1000_tx_ring_descriptors_remaining(${e1000::TxRing.ref} self)
-            {
-                if (self->tail == self->head) /* ring is empty */
-                    return 256; /* XXX: ${config.tx_ring_size}; */
-                if (self->tail > self->head)
-                    /* XXX: ${config.tx_ring_size} */
-                    return 256 - (self->tail - self->head);
-                return self->head - self->tail;
-            }
-
-            static int          rtx_e1000_tx_ring_tso_cksum_offload(${e1000::TxRing.ref} self, ${Socket::SKBuff.ref} skb)
-            {
-                ${Socket::AbstractSKBuff.ref} k_skb = skb->skbuff;
-                return skb_is_gso(${local.k_skb.k_sk_buff}) || ${local.k_skb.k_sk_buff}->ip_summed == CHECKSUM_PARTIAL;
-            }
-
-            static void         rtx_e1000_tx_ring_put(${e1000::TxRing.ref} self, ${Socket::SKBuff.ref} skb)
-            {
-                WARN_ON(!skb);
-
-                /*
-                 * Mark it as the last buffer (EOP) and ask the card to
-                 * insert the Ethernet FCS (Frame Check Sequence).
-                 *
-                 * XXX: it sucks to use skb_headlen() here (this part of the
-                 * code shouldn't be aware of it and use something more
-                 * abstract.
-                 */
-                ${Socket::AbstractSKBuff.ref} k_skb = skb->skbuff;
-                ${e1000::TxDescriptor.ref} tx_desc = &self->base[self->tail];
-                tx_desc->lower.data = cpu_to_le32(
-                        E1000_TXD_CMD_EOP  |
-                        E1000_TXD_CMD_IFCS |
-                        E1000_TXD_CMD_RS   |
-                        skb_headlen(${local.k_skb.k_sk_buff}));
-                tx_desc->upper.data = 0;
-                tx_desc->buff_addr = cpu_to_le64(${local.skb.dma_handle.k_dma_handle});
-                memcpy(&self->skbuffs[self->tail], ${local.k_skb.k_sk_buff}, sizeof(*${local.k_skb.k_sk_buff}));
-                self->tail = (self->tail + 1) % ${config.tx_ring_size};
-            }
-
-            /* FIXME: See issue #54 */
-            static void         rtx_e1000_tx_ring_start_xmit(${e1000::TxRing.ref} self, /*const*/ ${e1000::Context.ref} hw_ctx)
-            {
-                pr_info("%s: start_xmit: moving tail to %d/%d", ${config.name}, self->tail, ${config.tx_ring_size});
-                rtx_e1000_register_write32(hw_ctx, E1000_TDT, self->tail);
-            }
-        }
-
-        chunk   Ethernet::adapter_init_tx(Ethernet::Device rtx_ether_ctx)
-        {
-            {
-                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-
-                /*
-                 * Transmission initialization (section 14.5):
-                 *
-                 * 1. Allocate the transmit descriptors ring and map it to make it
-                 *    accessible by the device;
-                 * 2. Write the start address of the ring in TDBAL/TDBAH and set
-                 *    TDLEN to the size of the ring;
-                 * 3. Set the TDH/TDT indexes to the beginning and end of the ring;
-                 * 4. Set TCTL.PSP to pad short packets and TCTL.EN to enable the
-                 *    transmitter.
-                 */
-
-                /* 1. Allocate the tx ring */
-                hw_ctx->tx_ring.size = ${config.tx_ring_size} * sizeof(*hw_ctx->tx_ring.base);
-                hw_ctx->tx_ring.size = ALIGN(hw_ctx->tx_ring.size, 4096);
-                hw_ctx->tx_ring.base = dma_alloc_coherent(
-                        ${rtx_ether_ctx.device},
-                        hw_ctx->tx_ring.size,
-                        &hw_ctx->tx_ring.dma_base,
-                        GFP_KERNEL);
-                if (!hw_ctx->rx_ring.base)
-                {
-                    ${Log::info("adapter_init_tx: cannot allocate the descriptors for the tx ring")};
-                    /*
-                     * XXX: If there is something else to rollback in the enclosing
-                     * function, this won't be done.
-                     */
-                    return -ENOMEM;
-                }
-
-                ${Log::info("adapter_init_tx: tx descriptors allocated")};
-
-                /* 2. Save the emplacement and the size of the ring in TDBA/TDLEN */
-                rtx_e1000_register_write32(hw_ctx, E1000_TDBAL, hw_ctx->tx_ring.dma_base & 0xffffffff);
-                rtx_e1000_register_write32(hw_ctx, E1000_TDBAH, hw_ctx->tx_ring.dma_base >> 32);
-                rtx_e1000_register_write32(hw_ctx, E1000_TDLEN, hw_ctx->tx_ring.size);
-
-                /* 3. Setup TDH/TDT to zero: the queue is empty */
-                rtx_e1000_register_write32(hw_ctx, E1000_TDH, 0);
-                rtx_e1000_register_write32(hw_ctx, E1000_TDT, 0);
-                hw_ctx->tx_ring.head = 0;
-                hw_ctx->tx_ring.tail = 0;
-
-                /* 4. Set TCTL.PSP and enable the transmitter */
-                rtx_e1000_register_set32(hw_ctx, E1000_TCTL, E1000_TCTL_PSP|E1000_TCTL_EN);
-
-                ${Log::info("adapter_init_tx: transmit registers configured and transmitter enabled")};
-            }
-        }
-
-        method  clean()
-        {
-            rtx_e1000_tx_ring_clean(${self});
-        }
-
-        method   descriptors_remaining()
-        {
-            rtx_e1000_tx_ring_descriptors_remaining(${self});
-        }
-
-        method   tso_cksum_offload(Socket::SKBuff skb)
-        {
-        }
-
-        method   put(Socket::SKBuff skb)
-        {
-            rtx_e1000_tx_ring_put(${self}, &${skb});
-        }
-
-        method   start_xmit(e1000::Context ctx)
-        {
-            rtx_e1000_tx_ring_start_xmit(${self}, ${ctx});
-        }
-
-        method init()
-        {
+            rtx_e1000_alloc_rx_ressources(${self});
         }
 
         map
         {
+            descs: ((${self})->descs); // TODO: fix cast pour directement avoir les descs
+            desc_size: sizeof(/* XXX ${e1000::RxDescriptor} */int);
         }
     }
 
-    template type   e1000::Context()
+    template type e1000::TxRing()
     {
-        decl    data_types()
+        decl data_types()
         {
-            int                         bars;
-            unsigned char /* __iomem */ *ioaddr;
-            ${e1000::RxRing.scalar}     rx_ring;
-            ${e1000::TxRing.scalar}     tx_ring;
+            ${e1000::Ring}  ring;
         }
 
-        chunk   Ethernet::HardwareContext()
+        chunk LKM::prototypes()
         {
-            /*
-             * Force the generation of the structure in the "headers" part, we
-             * have to do this since we do not use the structure in this blt
-             * (we hacked a bit and used it in ethernet.blt directly).
-             */
-            ${e1000::Context}   hw_ctx;
+            static int  rtx_e1000_alloc_tx_ressources(${e1000::TxRing.ref});
         }
 
-        chunk   Ethernet::adapter_init_context(Ethernet::Device rtx_ether_ctx,
-                                               Builtin::number bars,
-                                               Builtin::symbol ioaddr)
+        chunk LKM::code()
         {
+            static int  rtx_e1000_alloc_tx_ressources(${e1000::TxRing.ref} self)
             {
-                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-                hw_ctx->bars = ${bars};
-                hw_ctx->ioaddr = ${ioaddr};
+                return 0;
             }
         }
 
-        chunk   Ethernet::adapter_reset(Ethernet::Device rtx_ether_ctx)
+        method init(e1000::MMIO io, Builtin::number desc_count)
         {
-            {
-                /* XXX Naming this variable 'hw_ctx' kicks the decl out of the generated code */
-                ${e1000::Context.ref} tmp_hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-                rtx_e1000_register_write32(tmp_hw_ctx, E1000_CTRL, E1000_CMD_RST);
-                udelay(10);
-            }
+            ${self.ring.init(local.io, local.desc_count, self.desc_size)};
         }
 
-        chunk   Ethernet::adapter_load_mac_address(Ethernet::Device rtx_ether_ctx)
+        method alloc()
         {
-            {
-                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-                /* Shamelessly borrowed from Minix */
-                for (int i = 0; i < 3; ++i)
-                {
-                    rtx_e1000_register_write32(hw_ctx, E1000_EEPROM_READ, (i << 8) | 1);
-                    int value;
-                    do
-                        value = rtx_e1000_register_read32(hw_ctx, E1000_EEPROM_READ);
-                    while ((value & (1 << 4)) == 0);
-                    value >>= 16;
-                    /*
-                     * NOTE: I'm not sure if Ethernet::Device should be
-                     * accessed directly here. But since we need to take it in
-                     * parameter (so we can get back our e1000::Context) it
-                     * seems inadequate to set this in another way:
-                     */
-                    ${rtx_ether_ctx.dev_addr}[i * 2] = value & 0xff;
-                    ${rtx_ether_ctx.dev_addr}[i * 2 + 1] = (value >> 8) & 0xff;
-                }
-                ${Log::info("e1000::create: mac address loaded from the EEPROM")};
-            }
-        }
-
-        chunk   Ethernet::adapter_setup(Ethernet::Device rtx_ether_ctx)
-        {
-            {
-                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-
-                /*
-                 * "General Configuration" (section 14.3):
-                 *
-                 * - CTRL.ASDE/CTRL.SLU: Let the PHY handle the speed detection &
-                 *   negociation;
-                 * - CTRL.LRST/FRCSPD: Unset them to initiate the auto-negociation;
-                 * - CTRL.PHY_RST: Unset it;
-                 * - CTRL.ILOS: Unset it (ILOS is Invert Loss Of Signal);
-                 * - CTRL.VME: Make sure it's not set to disable VLAN support;
-                 * - Set the control flow registers to 0;
-                 * - Finally, initialize all the statistic registers from
-                 *   E1000_CRCERRS to E1000_TSCTFC.
-                 */
-                rtx_e1000_register_set32(hw_ctx, E1000_CTRL,
-                                         E1000_CMD_ASDE |
-                                         E1000_CMD_SLU);
-                rtx_e1000_register_unset32(hw_ctx, E1000_CTRL,
-                                           E1000_CMD_LRST    |
-                                           E1000_CMD_FRCSPD  |
-                                           E1000_CMD_PHY_RST |
-                                           E1000_CMD_ILOS    |
-                                           E1000_CMD_VME);
-                rtx_e1000_register_write32(hw_ctx, E1000_FCAH, 0);
-                rtx_e1000_register_write32(hw_ctx, E1000_FCAL, 0);
-                rtx_e1000_register_write32(hw_ctx, E1000_FCT, 0);
-                rtx_e1000_register_write32(hw_ctx, E1000_FCTTV, 0);
-                /*
-                 * XXX: Using int i clashes with another int i from the
-                 * "parent" chunk:
-                 */
-                for (int j = 0; j != 64; ++j)
-                    rtx_e1000_register_write32(hw_ctx, E1000_CRCERRS + j * 4, 0);
-
-                ${Log::info("adapter_setup: general configuration done")};
-            }
+            rtx_e1000_alloc_tx_ressources(${self});
         }
 
         map
         {
-            rx_ring: ((${self})->rx_ring);
-            //tx_ring: ((${self})->tx_ring); XXX Circular dep with Context
+            descs: ((${self})->descs); // TODO: fix cast pour directement avoir les descs
+            desc_size: sizeof(/* XXX ${e1000::TxDescriptor} */int);
         }
     }
 
-    template type   e1000::Register()
+    template type e1000::Context()
     {
-        decl    data_types()
+        decl data_types()
         {
-            E1000_CTRL          = 0x00000, /* Device Control - RW */
-            E1000_CTRL_DUP      = 0x00004, /* Device Control Duplicate (Shadow) - RW */
-            E1000_STATUS        = 0x00008, /* Device Status - RO */
-            E1000_EEPROM_FLASH  = 0x00010, /* EEPROM/Flash Control - RW */
-            E1000_EEPROM_READ   = 0x00014, /* EEPROM Read - RW */
-            E1000_CTRL_EXT      = 0x00018, /* Extended Device Control - RW */
-            E1000_FLA           = 0x0001C, /* Flash Access - RW */
-            E1000_MDIC          = 0x00020, /* MDI Control - RW */
-            E1000_IMS           = 0x000D0, /* Interrupt Mask Set */
-            E1000_IMC           = 0x000D8, /* Interrupt Mask Clear */
-            E1000_ICR           = 0x000C0, /* Interrupt Cause Read - R/clr */
-            E1000_FCAL          = 0x00028, /* Flow Control Address Low */
-            E1000_FCAH          = 0x0002c, /* Flow Control Address High */
-            E1000_FCT           = 0x00030, /* Flow Control Type */
-            E1000_RCTL          = 0x00100, /* Receive Control */
-            E1000_FCTTV         = 0x00170, /* Flow Control Transmit Timer Value */
-            E1000_TCTL          = 0x00400, /* Transmit Control */
-            E1000_CRCERRS       = 0x04000, /* CRC Error Count (base address of the statistic register spaces) */
-            E1000_RAL           = 0x05400, /* Receive Address Low */
-            E1000_RAH           = 0x05404, /* Receive Address High */
-            E1000_MTA           = 0x05200, /* Multicast Table Array */
-            E1000_RDBAL         = 0x02800, /* Receive Descriptor Base Address (Low 32 bits) */
-            E1000_RDBAH         = 0x02804, /* Receive Descriptor Base Address (High 32 bits) */
-            E1000_RDLEN         = 0x02808, /* Receive Descriptor Length */
-            E1000_RDH           = 0x02810, /* Receive Descriptor Head */
-            E1000_RDT           = 0x02818, /* Receive Descriptor Tail */
-            E1000_TDBAL         = 0x03800, /* Transmit Descriptor Base Address (Low 32 bits) */
-            E1000_TDBAH         = 0x03804, /* Transmit Descriptor Base Address (High 33 bits) */
-            E1000_TDLEN         = 0x03808, /* Transmit Descriptor Length */
-            E1000_TDH           = 0x03810, /* Transmit Descriptor Head */
-            E1000_TDT           = 0x03818, /* Transmit Descriptor Tail */
+            ${e1000::MMIO}      io;
+            ${e1000::TxRing}    tx_ring;
+            ${e1000::RxRing}    rx_ring;
         }
 
-        method init(Builtin::number value)
+        chunk LKM::includes()
         {
-            ${self} = ${value};
+            #include <linux/types.h>
         }
 
-        map
-        {
-        }
-    }
-
-    template type   e1000::Commands()
-    {
-        decl    data_types()
-        {
-            E1000_CMD_FD                    = 0x00000001, /* Full duplex.0=half; 1=full */
-            E1000_CMD_BEM                   = 0x00000002, /* Endian Mode.0=little,1=big */
-            E1000_CMD_PRIOR                 = 0x00000004, /* Priority on PCI. 0=rx,1=fair */
-            E1000_CMD_GIO_MASTER_DISABLE    = 0x00000004, /* Blocks new Master requests */
-            E1000_CMD_LRST                  = 0x00000008, /* Link reset. 0=normal,1=reset */
-            E1000_CMD_TME                   = 0x00000010, /* Test mode. 0=normal,1=test */
-            E1000_CMD_SLE                   = 0x00000020, /* Serial Link on 0=dis,1=en */
-            E1000_CMD_ASDE                  = 0x00000020, /* Auto-speed detect enable */
-            E1000_CMD_SLU                   = 0x00000040, /* Set link up (Force Link) */
-            E1000_CMD_ILOS                  = 0x00000080, /* Invert Loss-Of Signal */
-            E1000_CMD_SPD_SEL               = 0x00000300, /* Speed Select Mask */
-            E1000_CMD_SPD_10                = 0x00000000, /* Force 10Mb */
-            E1000_CMD_SPD_100               = 0x00000100, /* Force 100Mb */
-            E1000_CMD_SPD_1000              = 0x00000200, /* Force 1Gb */
-            E1000_CMD_BEM32                 = 0x00000400, /* Big Endian 32 mode */
-            E1000_CMD_FRCSPD                = 0x00000800, /* Force Speed */
-            E1000_CMD_FRCDPX                = 0x00001000, /* Force Duplex */
-            E1000_CMD_D_UD_EN               = 0x00002000, /* Dock/Undock enable */
-            E1000_CMD_D_UD_POLARITY         = 0x00004000, /* Defined polarity of Dock/Undock indication in SDP[0] */
-            E1000_CMD_FORCE_PHY_RESET       = 0x00008000, /* Reset both PHY ports, through PHYRST_N pin */
-            E1000_CMD_EXT_LINK_EN           = 0x00010000, /* enable link status from external LINK_0 and LINK_1 pins */
-            E1000_CMD_SWDPIN0               = 0x00040000, /* SWDPIN 0 value */
-            E1000_CMD_SWDPIN1               = 0x00080000, /* SWDPIN 1 value */
-            E1000_CMD_SWDPIN2               = 0x00100000, /* SWDPIN 2 value */
-            E1000_CMD_SWDPIN3               = 0x00200000, /* SWDPIN 3 value */
-            E1000_CMD_SWDPIO0               = 0x00400000, /* SWDPIN 0 Input or output */
-            E1000_CMD_SWDPIO1               = 0x00800000, /* SWDPIN 1 input or output */
-            E1000_CMD_SWDPIO2               = 0x01000000, /* SWDPIN 2 input or output */
-            E1000_CMD_SWDPIO3               = 0x02000000, /* SWDPIN 3 input or output */
-            E1000_CMD_RST                   = 0x04000000, /* Global reset */
-            E1000_CMD_RFCE                  = 0x08000000, /* Receive Flow Control enable */
-            E1000_CMD_TFCE                  = 0x10000000, /* Transmit flow control enable */
-            E1000_CMD_RTE                   = 0x20000000, /* Routing tag enable */
-            E1000_CMD_VME                   = 0x40000000, /* IEEE VLAN mode enable */
-            E1000_CMD_PHY_RST               = 0x80000000, /* PHY Reset */
-            E1000_CMD_SW2FW_INT             = 0x02000000, /* Initiate an interrupt to manageability engine */
-            E1000_INTR_TXDW                 = 0x00000001, /* Transmit desc written back */
-            E1000_INTR_TXQE                 = 0x00000002, /* Transmit Queue empty */
-            E1000_INTR_LSC                  = 0x00000004, /* Link Status Change */
-            E1000_INTR_RXSEQ                = 0x00000008, /* rx sequence error */
-            E1000_INTR_RXDMT0               = 0x00000010, /* rx desc min. threshold (0) */
-            E1000_INTR_RXO                  = 0x00000040, /* rx overrun */
-            E1000_INTR_RXT0                 = 0x00000080, /* rx timer intr (ring 0) */
-            E1000_INTR_MDAC                 = 0x00000200, /* MDIO access complete */
-            E1000_RAH_AV                    = (1 << 31),  /* Set the MAC Address as Valid */
-            E1000_RCTL_EN                   = (1 << 1),   /* Receiver Enable */
-            E1000_RCTL_BSEX                 = (1 << 25),  /* Buffer Size Extension */
-            E1000_RCTL_BSIZE_256            = ((1 << 16) | (1 << 17)),
-            E1000_RCTL_BSIZE_512            = (1 << 17),
-            E1000_RCTL_BSIZE_1024           = (1 << 16),
-            E1000_RCTL_BSIZE_2048           = 0,
-            E1000_RCTL_BSIZE_4096           = (E1000_RCTL_BSEX | (1 << 16) | (1 << 17)),
-            E1000_RCTL_BSIZE_8192           = (E1000_RCTL_BSEX | (1 << 17)),
-            E1000_RCTL_BSIZE_16384          = (E1000_RCTL_BSEX | (1 << 16)),
-            E1000_TCTL_EN                   = (1 << 1),   /* Transmitter Enable */
-            E1000_TCTL_PSP                  = (1 << 3),   /* Pad Short Packet */
-        }
-
-        map
-        {
-        }
-    }
-
-    template type   e1000::TxDescriptorFlags()
-    {
-        decl  data_types()
-        {
-            E1000_TXD_DTYP_D        = 0x00100000, /* Data Descriptor */
-            E1000_TXD_DTYP_C        = 0x00000000, /* Context Descriptor */
-            E1000_TXD_POPTS_IXSM    = 0x01,       /* Insert IP checksum */
-            E1000_TXD_POPTS_TXSM    = 0x02,       /* Insert TCP/UDP checksum */
-            E1000_TXD_CMD_EOP       = 0x01000000, /* End of Packet */
-            E1000_TXD_CMD_IFCS      = 0x02000000, /* Insert FCS (Ethernet CRC) */
-            E1000_TXD_CMD_IC        = 0x04000000, /* Insert Checksum */
-            E1000_TXD_CMD_RS        = 0x08000000, /* Report Status */
-            E1000_TXD_CMD_RPS       = 0x10000000, /* Report Packet Sent */
-            E1000_TXD_CMD_DEXT      = 0x20000000, /* Descriptor extension (0 = legacy) */
-            E1000_TXD_CMD_VLE       = 0x40000000, /* Add VLAN tag */
-            E1000_TXD_CMD_IDE       = 0x80000000, /* Enable Tidv register */
-            E1000_TXD_STAT_DD       = 0x00000001, /* Descriptor Done */
-            E1000_TXD_STAT_EC       = 0x00000002, /* Excess Collisions */
-            E1000_TXD_STAT_LC       = 0x00000004, /* Late Collisions */
-            E1000_TXD_STAT_TU       = 0x00000008, /* Transmit underrun */
-            E1000_TXD_CMD_TCP       = 0x01000000, /* TCP packet */
-            E1000_TXD_CMD_IP        = 0x02000000, /* IP packet */
-            E1000_TXD_CMD_TSE       = 0x04000000, /* TCP Seg enable */
-            E1000_TXD_STAT_TC       = 0x00000004, /* Tx Underrun */
-        }
-
-        map
-        {
-        }
-    }
-
-    /* TODO: make that a method of e1000::Context */
-    template sequence   e1000::print_status(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk   LKM::prototypes()
+        chunk LKM::prototypes()
         {
             static void rtx_e1000_print_status(${e1000::Context.ref});
         }
 
-        chunk   LKM::code()
+        chunk LKM::code()
         {
             static void rtx_e1000_print_status(${e1000::Context.ref} hw_ctx)
             {
-                unsigned int status = rtx_e1000_register_read32(hw_ctx, E1000_STATUS);
-                    ${Log::info("card status:")};
-                /*
-                 * we can't use Log::info below because it just accept a string
-                 * (as opposed to a format string with its parameters).
-                 */
+                unsigned int status = rtx_e1000_reg_read32(hw_ctx, E1000_STATUS);
+                ${Log::info("card status:")};
+                // XXX We can't use Log::info below because it just accept a
+                // string (as opposed to a format string with its parameters):
                 pr_info("\tRegister value: 0x%x\n", status);
                 pr_info("\tMode: %s\n", (status & 1) ? "Full": "Half");
                 pr_info("\tLink: %s\n", (status & 2) ? "Up" : "Down");
